#!/bin/bash # Run the Docker tests for the SDP # Note that this file is expecting to be mapped into the root of the workspace # and with the sdp directory in the same root. # So workspace view should look something like: # View: # //guest/perforce_software/sdp/main/... //myws.sdp/sdp/... oses="" # This file should be in <workspace-root>/sdp/test/ # We calculate dir relative to directory of script script_dir="${0%/*}" root_dir="$(cd "$script_dir/../.."; pwd -P)" # Allow the specific platform to be specified via parameter if [ ,"$1" = ,"ubuntu20" ] ; then oses="ubuntu20" elif [ ,"$1" = ,"centos" ] ; then oses="centos7" elif [ ,"$1" = ,"centos6" ] ; then oses="centos6" elif [ ,"$1" = ,"centos7" ] ; then oses="centos7" elif [ ,"$1" = ,"ubuntu" ] ; then oses="ubuntu20" else oses="ubuntu20 centos6 centos7" oses="centos7" # Default override fi # Directory where test output is put by the container # Easier to make it under sdp which is a mounted volume test_output_dir="$script_dir/output" [[ -d "$test_output_dir" ]] || mkdir "$test_output_dir" all_test_output="$test_output_dir/alltests.out" if [ -f $all_test_output ] ; then rm $all_test_output fi echo Running SDP tests tests_failed=0 for os in $oses do test_output="$test_output_dir/test-${os}.out" if [[ -f $test_output ]]; then rm $test_output fi docker_dir="$root_dir/sdp/test/docker" dockerfile_base=${docker_dir}/Dockerfile.${os}.base dockerfile_sdp=${docker_dir}/Dockerfile.${os}.sdp # Build the base Docker for the OS, and then the SDP variant on top docker build --rm=true -t=perforce/${os}-base -f ${dockerfile_base} ${docker_dir} docker build --rm=true -t=perforce/${os}-sdp -f ${dockerfile_sdp} ${docker_dir} # Run the Docker image, mounting the /sdp directory within it. The SDP image # has a default RUN command which is configured within it. # We don't directly stop on error but process a little later below so that nice # messages are written to Jenkins console outut. set +e echo "docker run --rm -v ${PWD}/sdp:/sdp -e TESTOS=${os} perforce/${os}-sdp" docker run --rm -v ${PWD}/sdp:/sdp -e TESTOS=${os} perforce/${os}-sdp tests_failed=$? set -e echo $os>> $all_test_output # Avoid Jenkins immediately failing job without letting us cat the output set +e cat $test_output>> $all_test_output set -e if [ $tests_failed -ne 0 ]; then break fi done cat $all_test_output exit $tests_failed
# | Change | User | Description | Committed | |
---|---|---|---|---|---|
#1 | 27246 | Jessie Fernandez | Branch for Jessie Fernandez | ||
//guest/perforce_software/sdp/dev/test/run_docker_tests.sh | |||||
#16 | 27002 | C. Thomas Tyler |
Updated ubuntu tests to add needed utilities, and change from testing Ubuntu 16.04 to 20.04. Changed 'centos' to imply cento7 rather than centos6 (which we shoud drop soon). |
||
#15 | 26987 | Robert Cowham | Change order of tests so centos7 is first | ||
#14 | 26982 | C. Thomas Tyler |
mkdirs.sh v4.1.0: * Accounted for directory structure change of Maintenance to Unsupported. * Added standard command line processing with '-h' and '-man' doc flags, and other flags (all documented). * Added in-code docs and updated AsciiDoc. * Enhanced '-test' mode to simulate /hx* mounts. * Enhanced preflight testing, and fixed '-test' mode installs. * Added support for installing to an alternate root directory. * Added '-s <ServerID>' option to override REPLICA_ID. * Added '-S <TargetServerID>' used for replicas of edge servers. * Added '-t <server_type>' option to override SERVER_TYPE. * Added '-M' option to override mount points. * Added '-f' fast option to skip big chown/chmod commands, and moved those commands near the end as well. verify_sdp.sh v5.9.0: * Added check for /p4/Version file, and checked that other legacy SDP methods of checking version * Added sanity check for crontab. * Added 'test skip' mechanism to skip certain tests: - crontab: Skip crontab check. Use this if you do not expect crontab to be configured, perhaps if a different scheduler is used. - license: Skip license related checks. - version: Skip version checks. - excess: Skip checks for excess copies of p4d/p4p/p4broker in PATH. * Added VERIFY_SDP_SKIP_TEST_LIST setting ton instance_vars.template, to define a standard way to have verify_sdp.sh always skip certain tests for a site. * Extended '-online' checks to check for bogus P4MASTERPORT, a common config error. Update test_SDP.py: * Adjusted test suite to account for various changes in mkdirs.sh. * Added 'dir' parameter to run_cmd() and sudo_cmd(), to run a command from a specified directory (as required to test new mkdirs.sh) * Added check_links() similar to existing check_dirs() function. === Upgrade Process Changes === Made /p4/common/bin/p4d/p4/p4broker/p4p shell script rather than binary. This changes the way SDP new binaries are staged for upgrade. For safety, exes are now staged to a director outside the PATH, the /p4/sdp/exes folder. A new 'get_latest_exes.sh' script simplifies the task of pulling executables from the Perforce FTP server. This can be used 'as is' for environments with outbound internet access, and is useful in any case to describe now to acquire binaries. This addresses an issue where a p4d binary staged for a future upgrade might be called before the actual upgrade is performed. upgrade.sh v4.0.0: * All preflight checks are now done first. Added '-p' to abort after preflight. * Added '-n' to show what would be done before anything is executed. * Minimalist logic to start/stop only servers that are upgrade, and apply upgrades only as needed. * Staging of exes for upgrade is now separate from /p4/common/bin * Improved in-code docs, added '-h' and '-man' options. * Retained pre/post P4D 2019.1 upgrade logic. |
||
#13 | 25554 | Robert Cowham | Automated tests for calling upgrade.sh | ||
#12 | 25153 | Robert Cowham |
Change scripts to be able to be run from workspace root sdp/test/run_docker_tests.sh So no longer requires funny mapping in workspace view (see README.md for view) |
||
#11 | 25151 | Robert Cowham | Update p4d version to 18.2 | ||
#10 | 25149 | Robert Cowham |
Changes to docker files as part of prep for multi-container work Centos6 & 7 now install python 3.6 from ISU Community as pre-built Refer to p4python==17.2 to avoid need to compile Changes to test infrastructure only |
||
#9 | 24581 | Robert Cowham | Fix test version for Perforce | ||
#8 | 22199 | C. Thomas Tyler | Updating to 2017.1 as it is now GA. | ||
#7 | 20880 | Robert Cowham | Improve error handling - tail the log file so errors more visible in Jenkins failures | ||
#6 | 19407 | Russell C. Jackson (Rusty) | Updated p4 version to 16.1 | ||
#5 | 19367 | Robert Cowham | Improve error handling for Jenkinsß | ||
#4 | 19366 | Robert Cowham | Improve error messages hopefully when run by Jenkins | ||
#3 | 19099 | Robert Cowham | Minor refactor to make things a little clearer as to test file location. | ||
#2 | 19045 | Robert Cowham |
Add docker file for Centos7 Refactor to move common stuff to a shell script. |
||
#1 | 19019 | Robert Cowham | Run ubuntu |